<?php
/**                                                                
 * @package        Joomla16.Tutorials
 * @subpackage    Components
 * @copyright    Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @author        OnClick Solutions ltd
 * @link        http://www.helponclick.com
 * @license        http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla controller library
jimport('joomla.application.component.controller');

/**
 * General Controller of HelpOnclick component
 */
class HelpOnclickController extends JControllerLegacy
{

    public function __construct($config = array())
    {
        parent::__construct($config);
        if(!isset($this->input)){
            $this->input = JFactory::getApplication()->input;
        }
    }

    /**
     * display task
     *
     * @return void
     */
    function display($cachable = false) 
    {
        // set default view if not set

        $this->input->set('view', $this->input->get('view', 'setup'));

        // call parent behavior
        parent::display($cachable);

    }
    function connect() {
        $response_errors = array ("Invalid email address<br />",
                                "error:Can't find account, please contact support"); 
        $helponclick_account_email = $this->input->get('helponclick_account_email', '', 'string');
        $helponclick_account_password = $this->input->get('helponclick_account_password');
        
        if($helponclick_account_email!="" && $helponclick_account_password!="")  
        {
            //$response = file_get_contents('http://www.helponclick.com/code.php?email='.$helponclick_account_email.'&password='.md5($helponclick_account_password));
            $response = $this->_get_remote('http://www.helponclick.com/code.php?email='.$helponclick_account_email.'&password='.md5($helponclick_account_password));

            //if (in_array(trim($response), $response_errors)) 
            if (!strstr($response, "Error")===false)
            {
                
                //$this->setError($response);
                $this->setMessage($response, 'error');
                
                $this->setRedirect('index.php?option=com_helponclick');
            } else {
                $this->_update_option('email', $helponclick_account_email);
                $this->_update_option('password', $helponclick_account_password);
                $this->_update_option('script', urldecode($response));
                //die();
                $this->setMessage("Connected successfully, chat is installed"); 
                $this->setRedirect('index.php?option=com_helponclick');
        
            }
        }
        else
        {       
            $this->setMessage("Email address or password missing", "error"); 
            $this->setRedirect('index.php?option=com_helponclick&');    
        }
    }
    function reset() {
            $this->_update_option('email', '');
            $this->_update_option('password', '');
            $this->_update_option('script', '');
            //die();
            $this->setMessage("Success");
            $this->setRedirect('index.php?option=com_helponclick');
    }
    function update_code() {
        // JInput get string bug
        $this->_update_option('script', isset($_POST['helponclick_code_script']) ? $_POST['helponclick_code_script'] : '');
        $this->setMessage("Success");
        $this->setRedirect('index.php?option=com_helponclick');
    }
    
    function _get_remote($url, $port=80)
    {
        if(function_exists("curl_init"))
        {
            $curl_handle = curl_init();
            curl_setopt($curl_handle, CURLOPT_URL, $url);
            curl_setopt($curl_handle, CURLOPT_PORT , $port);
            curl_setopt($curl_handle, CURLOPT_HEADER, false);
            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
            curl_setopt($curl_handle, CURLOPT_POST, false);
            $data = curl_exec($curl_handle);
            curl_close($curl_handle);
        }
        else
        {
            $data = file_get_contents($url);
        }

        return $data;
    }

    function _update_option($name, $value) {
        $db =& JFactory::getDBO();
        $query = "
          SELECT COUNT(*)
            FROM #__helponclick
            WHERE name='$name'";
            
        $db->setQuery($query);
        $count = $db->loadResult();
        //print_r($count);
        //echo($count.'xx');
        if ($count) {
            $db->setQuery("update #__helponclick set value='$value' where name='$name'");
            $db->query();
        } else {
            $data = new stdClass();
            $data->id = null;
            $data->name = $name;
            $data->value = $value;

            $db->insertObject( '#__helponclick', $data, 'id');
        }
    }
}
